Bug 838608 - Review Request: shim - first stage UEFI bootloader
Review Request: shim - first stage UEFI bootloader
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nalin Dahyabhai
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-09 11:12 EDT by Matthew Garrett
Modified: 2013-01-10 02:53 EST (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-11-25 10:27:21 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
nalin: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Matthew Garrett 2012-07-09 11:12:39 EDT
Spec URL: http://www.codon.org.uk/~mjg59/shim/shim.spec
SRPM URL: http://www.codon.org.uk/~mjg59/shim/shim-0.1-1.fc17.src.rpm
Description: Initial UEFI bootloader that handles chaining to a trusted full bootloader under secure boot environments.
Fedora Account System Username: mjg59
Comment 1 Nalin Dahyabhai 2012-07-10 15:05:19 EDT
Using https://fedoraproject.org/wiki/Packaging:ReviewGuidelines as a reference:

MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
shim.src: W: spelling-error Summary(en_US) bootloader -> boot loader, boot-loader, boatload
shim.src: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
shim.x86_64: W: spelling-error Summary(en_US) bootloader -> boot loader, boot-loader, boatload
shim.x86_64: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
shim.x86_64: E: no-binary
shim-debuginfo.x86_64: E: empty-debuginfo-package
Spelling isn't really an issue here if the term is accurate.
FIX? The build process produces a shim.efi.debug file -- is that supposed to be in the debuginfo package, or are we expecting that there won't be any because the binary is not ELF?

MUST: The package must be named according to the Package Naming Guidelines.
OK: No official project site, but the name meets the guidelines and is consistent with comments in the main source file.

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
OK: shim.spec

MUST: The package must meet the Packaging Guidelines 
OK

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
CHECK: The stated license (MIT) is acceptable, though linking with (a partial bundled) OpenSSL libcrypto and with libgnuefi at the same time could be problematic.

MUST: The License field in the package spec file must match the actual license.
FIX? The notes in COPYRIGHT appear to match BSD (2 clause variant) as listed at https://fedoraproject.org/wiki/Licensing/BSD#2ClauseBSD more closely than https://fedoraproject.org/wiki/Licensing/MIT, though both are free licenses.

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
OK

MUST: The spec file must be written in American English.
OK

MUST: The spec file for the package MUST be legible.
OK

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
OK: tarball in source RPM matches tarball at location specified in .spec file.

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
OK: built on fedora-rawhide-x86_64 with mock

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
FIX? Does this need to be "ExclusiveArch: i686 x86_64 ia64" or similar, as gnu-efi, which is one of this package's build requirements, is?

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
OK

MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
N/A

MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
N/A

MUST: Packages must NOT bundle copies of system libraries.
FIX: Are the -mno-red-zone flag and static linking the main reasons for bundling OpenSSL's libcrypto here?  Can comments be added to the .spec file so that the rationale is known?

MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
N/A

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
FIX: The package includes /boot/efi/EFI/redhat/shim.efi; the gnu-efi package provides /boot/efi/EFI/redhat, but this package doesn't require gnu-efi.  Please add a "Requires: gnu-efi" to ensure that the directory is owned while the package is installed.

MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
OK

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
FIX: Please specify the desired permissions when calling 'install' during the %install phase.

MUST: Each package must consistently use macros.
OK

MUST: The package must contain code, or permissable content.
OK

MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
N/A

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
OK

MUST: Static libraries must be in a -static package.
MUST: Development files must be in a -devel package.
MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
N/A

MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
OK

MUST: All filenames in rpm packages must be valid UTF-8.
OK
Comment 2 eric@christensenplace.us 2012-07-24 19:58:10 EDT
rpmlint is finding the following errors:

Checking: shim-0.1-1.fc16.src.rpm
          shim-debuginfo-0.1-1.fc16.x86_64.rpm
          shim-0.1-1.fc16.x86_64.rpm
shim.src: W: spelling-error Summary(en_US) bootloader -> boot loader, boot-loader, boatload
shim.src: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
shim-debuginfo.x86_64: E: empty-debuginfo-package
shim.x86_64: W: spelling-error Summary(en_US) bootloader -> boot loader, boot-loader, boatload
shim.x86_64: W: spelling-error %description -l en_US bootloader -> boot loader, boot-loader, boatload
shim.x86_64: E: no-binary
3 packages and 0 specfiles checked; 2 errors, 4 warnings.
Comment 3 Matthew Garrett 2012-07-28 00:56:25 EDT
"FIX? The build process produces a shim.efi.debug file -- is that supposed to be in the debuginfo package, or are we expecting that there won't be any because the binary is not ELF?"

There's no real way to use the debuginfo, since the binary never runs under the installed system. Using standard debug mechanisms isn't possible.

"CHECK: The stated license (MIT) is acceptable, though linking with (a partial bundled) OpenSSL libcrypto and with libgnuefi at the same time could be problematic."

gnuefi has been relicensed to BSD and I've uploaded an updated version to rawhide.

"FIX? The notes in COPYRIGHT appear to match BSD (2 clause variant) as listed at https://fedoraproject.org/wiki/Licensing/BSD#2ClauseBSD more closely than https://fedoraproject.org/wiki/Licensing/MIT, though both are free licenses."

Changed to BSD.

"FIX? Does this need to be "ExclusiveArch: i686 x86_64 ia64" or similar, as gnu-efi, which is one of this package's build requirements, is?"

Made ExclusiveArch: x86_64 (it doesn't support other relocation formats)

"FIX: Are the -mno-red-zone flag and static linking the main reasons for bundling OpenSSL's libcrypto here?  Can comments be added to the .spec file so that the rationale is known?"

Yes. I've added some comments.

"FIX: The package includes /boot/efi/EFI/redhat/shim.efi; the gnu-efi package provides /boot/efi/EFI/redhat, but this package doesn't require gnu-efi.  Please add a "Requires: gnu-efi" to ensure that the directory is owned while the package is installed."

Done.

"FIX: Please specify the desired permissions when calling 'install' during the %install phase."

Done, although install defaults to 0755 in the absence of anything else.

New SRPM and spec uploaded to http://www.codon.org.uk/~mjg59/shim/
Comment 4 Nalin Dahyabhai 2012-07-30 18:24:11 EDT
(In reply to comment #3)
> "FIX? The build process produces a shim.efi.debug file -- is that supposed
> to be in the debuginfo package, or are we expecting that there won't be any
> because the binary is not ELF?"
> 
> There's no real way to use the debuginfo, since the binary never runs under
> the installed system. Using standard debug mechanisms isn't possible.

Fair enough.  Is the .debug file useful with any other tools?  If so, does it make sense to try to get it into the debuginfo subpackage?  If not, http://fedoraproject.org/wiki/Packaging:Debuginfo notes a way to disable generation of a debuginfo subpackage.  Doing so and noting why it's done could be useful for people who wonder about this in the future.
 
> "CHECK: The stated license (MIT) is acceptable, though linking with (a
> partial bundled) OpenSSL libcrypto and with libgnuefi at the same time could
> be problematic."
> 
> gnuefi has been relicensed to BSD and I've uploaded an updated version to
> rawhide.

OK.

> "FIX? The notes in COPYRIGHT appear to match BSD (2 clause variant) as
> listed at https://fedoraproject.org/wiki/Licensing/BSD#2ClauseBSD more
> closely than https://fedoraproject.org/wiki/Licensing/MIT, though both are
> free licenses."
> 
> Changed to BSD.

OK.
 
> "FIX? Does this need to be "ExclusiveArch: i686 x86_64 ia64" or similar, as
> gnu-efi, which is one of this package's build requirements, is?"
> 
> Made ExclusiveArch: x86_64 (it doesn't support other relocation formats)

OK.
 
> "FIX: Are the -mno-red-zone flag and static linking the main reasons for
> bundling OpenSSL's libcrypto here?  Can comments be added to the .spec file
> so that the rationale is known?"
> 
> Yes. I've added some comments.

Thanks!
 
> "FIX: The package includes /boot/efi/EFI/redhat/shim.efi; the gnu-efi
> package provides /boot/efi/EFI/redhat, but this package doesn't require
> gnu-efi.  Please add a "Requires: gnu-efi" to ensure that the directory is
> owned while the package is installed."
> 
> Done.

OK.
 
> "FIX: Please specify the desired permissions when calling 'install' during
> the %install phase."
> 
> Done, although install defaults to 0755 in the absence of anything else.
> 
> New SRPM and spec uploaded to http://www.codon.org.uk/~mjg59/shim/

OK.

(In reply to comment #2)
> rpmlint is finding the following errors:
> 
> Checking: shim-0.1-1.fc16.src.rpm
>           shim-debuginfo-0.1-1.fc16.x86_64.rpm
>           shim-0.1-1.fc16.x86_64.rpm
> shim.src: W: spelling-error Summary(en_US) bootloader -> boot loader,
> boot-loader, boatload
> shim.src: W: spelling-error %description -l en_US bootloader -> boot loader,
> boot-loader, boatload
> shim-debuginfo.x86_64: E: empty-debuginfo-package
> shim.x86_64: W: spelling-error Summary(en_US) bootloader -> boot loader,
> boot-loader, boatload
> shim.x86_64: W: spelling-error %description -l en_US bootloader -> boot
> loader, boot-loader, boatload
> shim.x86_64: E: no-binary
> 3 packages and 0 specfiles checked; 2 errors, 4 warnings.

Whether it's spelled "bootloader" or "boot loader" seems to be up for debate (rpmlint wants the latter, but the former _does_ show up in my /usr/share/dict/words), so my personal inclination is to give these a pass.
Comment 5 Matthew Garrett 2012-08-07 18:05:04 EDT
I can't see the debug file being useful, so I've disabled the debuginfo build.
Comment 6 Nalin Dahyabhai 2012-08-10 15:27:26 EDT
Whoops, sorry, I seem to dropped a ball here.  Signing on as the reviewer of record and doing the things with the flags.
Comment 7 Nalin Dahyabhai 2012-08-10 15:37:36 EDT
(In reply to comment #5)
> I can't see the debug file being useful, so I've disabled the debuginfo
> build.

Okay, it looks like that's done in the build machinery rather than the .spec file, but either way things look alright to me.  Looks like we're done with the review part; setting fedora-review to '+'.
Comment 8 Gwyn Ciesla 2012-08-13 10:52:03 EDT
Please include an SCM request. . .

http://fedoraproject.org/wiki/Package_SCM_admin_requests
Comment 9 Matthew Garrett 2012-08-13 10:55:15 EDT
New Package SCM Request
=======================
Package Name: shim
Short Description: First-stage UEFI bootloader
Owners: mjg59, pjones
Branches: f18
InitialCC:
Comment 10 Gwyn Ciesla 2012-08-13 10:57:39 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.